
/* nxlcau2f.h			*/
/* header file for nxlcau2f.c	*/
/* 12 May 1989			*/

# define COLGRAF		4  /* graph resolution			*/
# define T80X25			3  /* text resolution			*/
# define WHCYMAG		1  /* color quad for normal screen	*/
# define YELREGR		2  /* alternative color palette 	*/
# define CR		        5  /* cursor reference - row editor	*/
# define CM		        7  /* cursor reference - main menu	*/
# define CL		       11  /* cursor reference - line editor	*/
# define AL     	    16384  /* array length (screen width)	*/
# define SL		       40  /* short array length		*/
# define YL		      320  /* screen length (normally 320)	*/
# define KK	     		2  /* number of states per cell		*/
# define RR			6  /* length of neighborhood = 2r+1	*/ 
# define DS 	KK*KK*KK*KK*KK*KK  /* 2^RR (distinct neighborhoods)	*/
# define TS	      RR*(KK-1)+1  /* distinct sums w/totalistic rule	*/
# define SS      ((RR-1)*(KK-1)+1) /* distinct sums w/stotalistic rule	*/
# define BD		       25  /* max number Bernstein coeffs	*/ 

# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define KF     (K8*K8)
# define AV	(KK*KK*KK*KK)

# define PDN        256         /* number of nodes in pair diagram  */
# define DN  (KK*KK*KK*KK*KK)	/* number of distinct de Bruijn nodes	*/
# define SDN	  65536  	/* nodes in subset diagram = 2^(KK^2r)	*/
# define CCY         12		/* circumference of max length cycle	*/
# define XCY	   4096		/* max number of cycles = KK^CCY	*/
# define XBD	   4096		/* max dimension de Bruijn diagram	*/
# define DDN	   4096		/* maximum nodes any de Bruijn diagram	*/
# define QDN	   4096		/* maximum nodes 2-D de Bruijn diagram	*/
# define QWN	   1024 	/* node list 2-D de Bruijn node & link  */

# define NX	 	       18  /* number of demonstration rules	*/
# define NY		       14  /* number of REC demonstrations  	*/

# define CLEN		       76  /* rec source program length	 	*/
# define PLEN		   8*CLEN  /* rec object program length	 	*/
# define CLEN2  300   /*  buffer length for rec source   */
# define PLEN2  900   /*  buffer length for rec object   */
# define NY2     24

# define XLEN 128

# define DROWS		20	/* no of rows in demo menu       */
# define DCOLS		36	/* column for second col in d.m. */

# define RROWS		20	/* no of rows in demo menu       */
# define RCOLS		32	/* column for second col in d.m. */

# define HCH   32	/* characters+1 in help menus (text screen)    */
# define GCH   26	/* characters+1 in help menus (graphic screen) */

# define RSYM		 4	/* number of rule symmetries = 2*k!	*/
# define WNML	        17	/* arry size to hold hex wolfram number */

typedef union ascrular {
	char one[DS]; 
	char six[KK][KK][KK][KK][KK][KK];
	} ascrular;

typedef union binrular {
	int one[DS]; 
	int six[KK][KK][KK][KK][KK][KK];
	} binrular;

typedef union parneih {
	char one[K5*K5];
	char two[K5][K5];
	char ten[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
	} parneih;

typedef union twoparn {
	char one[KF];
	char two[K8][K8];
	char four[K4][K4][K4][K4];
char sixteen[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
	} twoparn;


/* end nxlcau2f.h */
