
/* probkf.c						*/
/* program for LCAU2F option 't'			*/
/* calculate probabilities related to evolution		*/
/* generic portion of probkr.c which applies to radius  */
/* 2 1/2 automata and which do not make any explicit 	*/
/* use of the number of states. It is to be included in */
/* each specific probkr file.				*/
/* Harold V. McIntosh, 20 January 1992			*/

/*  Copyright (C) 1992  */
/*  Harold V. McIntosh  */

/* ---------------------------------------------------- */

/* gather totalistic neighborhood sums for one generation */
/* mm = number of cells */
/* b[cc]  = sum counts  */
onesum(mm,cc,b) int mm, cc, *b; {int i, j, k;
  for (i=0; i<cc; i++) b[i]=0;
  k=arr1[mm-5]+arr1[mm-4]+arr1[mm-3]+arr1[mm-2]+arr1[mm-1]+arr1[0]; b[k]++;
  k=arr1[mm-4]+arr1[mm-3]+arr1[mm-2]+arr1[mm-1]+arr1[0]+arr1[1]; b[k]++;
  k=arr1[mm-3]+arr1[mm-2]+arr1[mm-1]+arr1[0]+arr1[1]+arr1[2]; b[k]++;
  k=arr1[mm-2]+arr1[mm-1]+arr1[0]+arr1[1]+arr1[2]+arr1[3]; b[k]++;
  k=arr1[mm-1]+arr1[0]+arr1[1]+arr1[2]+arr1[3]+arr1[4]+arr1[5]; b[k]++;
  for (i=3; i<mm-3; i++) {k=0; for (j=i-3; j<i+3; j++) k+=arr1[j]; b[k]++;}
}

/* Generate coefficients of 2nd generation Bernstein Polynomial */
berncoef() {
int i, i0, i1, i2, i3, i4, i5;

for (i=0; i<BD; i++) bp[i]=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  if (ascrule[i0][i1][i2][i3][i4][i5]=='1') {
    i=i0+i1+i2+i3+i4+i5; bp[i]+=1.0; }
}

/* Generate coefficients of 3rd generation Bernstein Polynomial */
bernthrd() {
int i, i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, ia;
int j0, j1, j2, j3, j4, j5;

asctobin();
for (i=0; i<BD; i++) bp[i]=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (ia=0; ia<KK; ia++) {
  j0=binrule[i0][i1][i2][i3][i4][i5];
  j1=binrule[i1][i2][i3][i4][i5][i6];
  j2=binrule[i2][i3][i4][i5][i6][i7];
  j3=binrule[i3][i4][i5][i6][i7][i8];
  j4=binrule[i4][i5][i6][i7][i8][i9];
  j5=binrule[i5][i6][i7][i8][i9][ia];
  i=i0+i1+i2+i3+i4+i5+i6+i7+i8+i9+ia;
  if (ascrule[j0][j1][j2][j3][j4][j5]=='1') bp[i]+=1.0;
  }
}

/* Generate coefficients of 4th generation Bernstein Polynomial */
bernfrth() {}

/* Generate coefficients of 5th generation Bernstein Polynomial */
bernfith() {}

/* display frequencies in ascrule in color l */

asfreq(l) int l; {
int    i, j, i0, i1, i2, i3, i4, i5;
int    stat[KK], stall, stal, stac, star, starr, starrr;	/* statistic counts */
double staf[KK], t, pp;

videoscroll(BROW,0,BROW+8,40,0,0);
videocursor(0,BROW,0);
pp=1.0/((double)(KK*KK*KK*KK*KK*KK));
stall=0; stal=0; stac=0; star=0; starr=0; starrr=0;
for (i=0; i<KK; i++) stat[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++) {
  j=ascrule[i0][i1][i2][i3][i4][i5]-'0';
  stat[j]++;
  if(j==i0) starrr++;
  if(j==i1) starr++;
  if(j==i2) star++;
  if(j==i3) stac++;
  if(j==i4) stal++;
  if(j==i5) stall++;
  }
for (i=0; i<KK; i++) printf("%2d    - %5.2f\n",i,((double)stat[i])*pp);
printf("lleft  - %5.2f\n",((double)stall)*pp);
printf("left   - %5.2f\n",((double)stal)*pp);
printf("still  - %5.2f\n",((double)stac)*pp);
printf("right  - %5.2f\n",((double)star)*pp);
printf("rright - %5.2f\n",((double)starr)*pp);
printf("rrright- %5.2f\n",((double)starrr)*pp);
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
j=199-(int)(100.0*staf[1]);
i=CORG+(int)(100.0*staf[1]);
if (j>=2) videodot(j-2,i,l);
if (i>=2) videodot(j,i-2,l);
videodot(j,i,1);
if (i<=318) videodot(j,i+2,l);
if (j<=198) videodot(j+2,i,l);
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
videocursor(0,BROW,20);
printf("lambda:   %5.3f",1.0-staf[0]);
videocursor(0,BROW+1,20);
printf("entropy:  %5.3f",-t/log((double)KK));
}

/* evaluate the one-block probabilities after one generation */

onebl(x,a) double x[KK], a[KK]; {int i0, i1, i2, i3, i4, i5, j0;

for (j0=0; j0<KK; j0++) x[j0]=0.0;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++) {
  j0=ascrule[i0][i1][i2][i3][i4][i5]-'0';
  x[j0]+=a[i0]*a[i1]*a[i2]*a[i3]*a[i4]*a[i5];
  }
}

/* iterate the 1-block parameters to find self-consistent values */
/* graph the iterative steps in bar-chart form			 */
/* mm - length of line	*/
/* nn - number of lines	*/

oneblfreq(mm,nn) int mm, nn; {
int    ii, i, l, m, n;
double op[KK], np[KK];
double d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i=0; i<KK; i++) {op[i]=s; for (l=0; l<n; l++) videodot(0,m++,i);}

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  onebl(np,op);
  videodot(ii,m++,3);
  for (i=0; i<KK; i++) {
    n=(int)(f*np[i]); if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i);
    d=op[i]-np[i];
    e+=d*d;
    op[i]=np[i];
    }
  videodot(ii,m++,3);
  if (op[0]<=0.001) break;
  if (op[1]<=0.001) break;
  if (e<=0.0000001) break;
  }
videocursor(0,BROW+7,0);
printf("(1-block) "); 
for (i=0; i<KK; i++) printf("%2d:%5.3f ",i,op[i]);
}

/* evaluate the two-block probabilities after one generation */

twobl(x,a) double x[KK][KK], a[KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6;
int    j0, j1;
double w, b[KK];

for (j0=0; j0<KK; j0++) {for (j1=0; j1<KK; j1++) x[j0][j1]=0.0;}

for (j0=0; j0<KK; j0++) {b[j0]=0.0; for (j1=0; j1<KK; j1++) b[j0]+=a[j0][j1];}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++) {
  j0=ascrule[i0][i1][i2][i3][i4][i5]-'0';
  j1=ascrule[i1][i2][i3][i4][i5][i6]-'0';
  w=a[i0][i1]*a[i1][i2]*a[i2][i3]*a[i3][i4]*a[i4][i5]*a[i5][i6];
  if (w!=0.0) w/=b[i1]*b[i2]*b[i3]*b[i4]*b[i5];
  x[j0][j1]+=w;
  }
}

/* iterate the 2-block parameters to find self-consistent values */
/* graph the iterative steps in bar-chart form			 */
/* mm - length of line	*/
/* nn - number of lines	*/

twoblfreq(mm,nn) int mm, nn; {
int    ii, i, j, l, m, n;
double op[KK][KK], np[KK][KK];
double b[KK], d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i=0; i<KK; i++) {
for (j=0; j<KK; j++) {
  op[i][j]=s;
  for (l=0; l<n; l++) videodot(0,m++,j);
  }}
videodot(0,m++,3);

for (i=0; i<KK; i++) {b[i]=0.0; for (j=0; j<KK; j++) b[i]+=op[i][j];}
videodot(199-(int)(100.0*op[1][1]),(int)(100.0*b[1]),1);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  twobl(np,op);
  videodot(ii,m++,3);
  for (i=0; i<KK; i++) {
  for (j=0; j<KK; j++) {
    n=(int)(f*np[i][j]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,j);
    d=op[i][j]-np[i][j];
    e+=d<0.0?-d:d;
    op[i][j]=np[i][j];
    }}
  videodot(ii,m++,3);
  for (i=0; i<KK; i++) {b[i]=0.0; for (j=0; j<KK; j++) b[i]+=op[i][j];}
  videodot(199-(int)(100.0*op[1][1]),(int)(100.0*b[1]),2);
  if (e<=0.0001) break;
  }
videocursor(0,BROW+7,0);
printf("(2-block) "); 
for (i=0; i<KK; i++) printf("%2d:%5.3f ",i,b[i]);
videocursor(0,BROW+8,0);
for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
		printf("%1d%1d:%5.3f ",i,j,op[i][j]);
videodot(199-(int)(100.0*op[1][1]),(int)(100.0*b[1]),3);
videodot(199-(int)(100.0*op[1][1]),BORG+(int)(100.0*b[1]),1);
}

/* evaluate the three-block probabilities after one generation */

thrbl(x,a) double x[KK][KK][KK], a[KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6, i7;
int    j0, j1, j2;
double w, b[KK][KK];

for (j0=0; j0<KK; j0++) {
for (j1=0; j1<KK; j1++) {
  for (j2=0; j2<KK; j2++) x[j0][j1][j2]=0.0;
  b[j0][j1]=0.0;
  for (j2=0; j2<KK; j2++) b[j0][j1]+=a[j0][j1][j2];  
  }}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++) {
  j0=ascrule[i0][i1][i2][i3][i4][i5]-'0';
  j1=ascrule[i1][i2][i3][i4][i5][i6]-'0';
  j2=ascrule[i2][i3][i4][i5][i6][i7]-'0';
  w=a[i0][i1][i2]*a[i1][i2][i3]*a[i2][i3][i4]*a[i3][i4][i5]
	*a[i4][i5][i6]*a[i5][i6][i7];
  if (w!=0.0) w/=b[i1][i2]*b[i2][i3]*b[i3][i4]*b[i4][i5]
	*b[i5][i6];
  x[j0][j1][j2]+=w;
  }
}

/* iterate the 3-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

thrblfreq(mm,nn) int mm, nn; {
int    ii, i, j, k, l, m, n;
double op[KK][KK][KK], np[KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i=0; i<KK; i++)
for (j=0; j<KK; j++)
for (k=0; k<KK; k++) {
  op[i][j][k]=s;
  for (l=0; l<n; l++) videodot(0,m++,k);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  thrbl(np,op);
  videodot(ii,m++,3);
  for (i=0; i<KK; i++) {
  for (j=0; j<KK; j++) {
  for (k=0; k<KK; k++) {
    n=(int)(f*np[i][j][k]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,k);
    d=op[i][j][k]-np[i][j][k];
    e+=d<0.0?-d:d;
    op[i][j][k]=np[i][j][k];
    }}}
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }

for (i=0; i<KK; i++) {
  b[i]=0.0;
  for (j=0; j<KK; j++) {
  for (k=0; k<KK; k++) {
    b[i]+=op[i][j][k];
    }} }
videocursor(0,BROW+7,0);
printf("(3-block) "); 
for (i=0; i<KK; i++) printf("%2d:%5.3f ",i,b[i]);

for (i=0; i<KK; i++) {
for (j=0; j<KK; j++) {
  bb[i][j]=0.0;
  for (k=0; k<KK; k++) {
    bb[i][j]+=op[i][j][k];
    }} }

videocursor(0,BROW+8,0);
for (i=0; i<KK; i++) for (j=0; j<KK; j++) 
  printf("%1d%1d:%5.3f ",i,j,bb[i][j]);
videodot(199-(int)(100.0*bb[1][1]),BORG+(int)(100.0*b[1]),2);
}

/* evaluate the four-block probabilities after one generation */

foubl(x,a) double x[KK][KK][KK][KK], a[KK][KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6, i7, i8;
int    j0, j1, j2, j3;
double w, b[KK][KK][KK];

for (j0=0; j0<KK; j0++) {
for (j1=0; j1<KK; j1++) {
for (j2=0; j2<KK; j2++) {
  for (j3=0; j3<KK; j3++) x[j0][j1][j2][j3]=0.0;
  b[j0][j1][j2]=0.0;
  for (j3=0; j3<KK; j3++) b[j0][j1][j2]+=a[j0][j1][j2][j3];  
  }}}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++) {
  j0=ascrule[i0][i1][i2][i3][i4][i5]-'0';
  j1=ascrule[i1][i2][i3][i4][i5][i6]-'0';
  j2=ascrule[i2][i3][i4][i5][i6][i7]-'0';
  j3=ascrule[i3][i4][i5][i6][i7][i8]-'0';
  w=a[i0][i1][i2][i3];
  w*=a[i1][i2][i3][i4];
  w*=a[i2][i3][i4][i5];
  w*=a[i3][i4][i5][i6];
  w*=a[i4][i5][i6][i7];
  w*=a[i5][i6][i7][i8];
  if (w!=0.0) w/=b[i1][i2][i3]*b[i2][i3][i4]*b[i3][i4][i5]
	*b[i4][i5][i6]*b[i5][i6][i7];
  x[j0][j1][j2][j3]+=w;
  }
}

/* iterate the 4-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

foublfreq(mm,nn) int mm, nn; {
int    ii, i0, i1, i2, i3, l, m, n;
double op[KK][KK][KK][KK], np[KK][KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++) {
  op[i0][i1][i2][i3]=s;
  for (l=0; l<n; l++) videodot(0,m++,i3);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  foubl(np,op);
  videodot(ii,m++,3);
  for (i0=0; i0<KK; i0++) {
  for (i1=0; i1<KK; i1++) {
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
    n=(int)(f*np[i0][i1][i2][i3]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i3);
    d=op[i0][i1][i2][i3]-np[i0][i1][i2][i3];
    e+=d<0.0?-d:d;
    op[i0][i1][i2][i3]=np[i0][i1][i2][i3];
    }}}}
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }

for (i0=0; i0<KK; i0++) {
  b[i0]=0.0;
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++) {
    b[i0]+=op[i0][i1][i2][i3];
    } }

videocursor(0,BROW+7,0);
printf("(4-block) "); 
for (i0=0; i0<KK; i0++) printf("%2d:%5.3f ",i0,b[i0]);

for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  bb[i0][i1]=0.0;
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
    bb[i0][i1]+=op[i0][i1][i2][i3];
    }} }}

videocursor(0,BROW+8,0);
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  printf("%1d%1d:%5.3f ",i0,i1,bb[i0][i1]);
videodot(199-(int)(100.0*bb[1][1]),BORG+(int)(100.0*b[1]),2);
}

/* evaluate the five-block probabilities after one generation */

fivbl(x,a) double x[KK][KK][KK][KK][KK], a[KK][KK][KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6, i7, i8, i9;
int    j0, j1, j2, j3, j4;
double w, b[KK][KK][KK][KK];

for (j0=0; j0<KK; j0++) {
for (j1=0; j1<KK; j1++) {
for (j2=0; j2<KK; j2++) {
for (j3=0; j3<KK; j3++) {
  for (j4=0; j4<KK; j4++) x[j0][j1][j2][j3][j4]=0.0;
  b[j0][j1][j2][j3]=0.0;
  for (j4=0; j4<KK; j4++) b[j0][j1][j2][j3]+=a[j0][j1][j2][j3][j4];  
  }}}}

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++) {
  j0=ascrule[i0][i1][i2][i3][i4][i5]-'0';
  j1=ascrule[i1][i2][i3][i4][i5][i6]-'0';
  j2=ascrule[i2][i3][i4][i5][i6][i7]-'0';
  j3=ascrule[i3][i4][i5][i6][i7][i8]-'0';
  j4=ascrule[i4][i5][i6][i7][i8][i9]-'0';
  w=a[i0][i1][i2][i3][i4];
  w*=a[i1][i2][i3][i4][i5];
  w*=a[i2][i3][i4][i5][i6];
  w*=a[i3][i4][i5][i6][i7];
  w*=a[i4][i5][i6][i7][i8];
  w*=a[i5][i6][i7][i8][i9];
  if (w!=0.0) {
    w/=b[i1][i2][i3][i4];
    w/=b[i2][i3][i4][i5];
    w/=b[i3][i4][i5][i6];
    w/=b[i4][i5][i6][i7];
    w/=b[i5][i6][i7][i8];
    }
  x[j0][j1][j2][j3][j4]+=w;
  }
}

/* iterate the 5-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

fivblfreq(mm,nn) int mm, nn; {
int    ii, i0, i1, i2, i3, i4, l, m, n;
double op[KK][KK][KK][KK][KK], np[KK][KK][KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++) {
  op[i0][i1][i2][i3][i4]=s;
  for (l=0; l<n; l++) videodot(0,m++,i4);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  fivbl(np,op);
  videodot(ii,m++,3);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++) {
    n=(int)(f*np[i0][i1][i2][i3][i4]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i4);
    d=op[i0][i1][i2][i3][i4]-np[i0][i1][i2][i3][i4];
    e+=d<0.0?-d:d;
    op[i0][i1][i2][i3][i4]=np[i0][i1][i2][i3][i4];
    }
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }
for (i0=0; i0<KK; i0++) {
  b[i0]=0.0;
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
    b[i0]+=op[i0][i1][i2][i3][i4];
    }
videocursor(0,BROW+7,0);
printf("(5-block) "); 
for (i0=0; i0<KK; i0++) printf("%2d:%5.3f ",i0,b[i0]);

for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  bb[i0][i1]=0.0;
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  for (i4=0; i4<KK; i4++) {
    bb[i0][i1]+=op[i0][i1][i2][i3][i4];
    }} }}}

videocursor(0,BROW+8,0);
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  printf("%1d%1d:%5.3f ",i0,i1,bb[i0][i1]);
videodot(199-(int)(100.0*bb[1][1]),BORG+(int)(100.0*b[1]),2);
}

/* evaluate the six-block probabilities after one generation */

sixbl(x,a) double x[KK][KK][KK][KK][KK][KK], a[KK][KK][KK][KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, ia;
int    j0, j1, j2, j3, j4, j5;
double w, b[KK][KK][KK][KK][KK];

for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++) {
  for (j5=0; j5<KK; j5++) x[j0][j1][j2][j3][j4][j5]=0.0;
  b[j0][j1][j2][j3][j4]=0.0;
  for (j5=0; j5<KK; j5++) b[j0][j1][j2][j3][j4]+=a[j0][j1][j2][j3][j4][j5];  
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (ia=0; ia<KK; ia++) {
  j0=ascrule[i0][i1][i2][i3][i4][i5]-'0';
  j1=ascrule[i1][i2][i3][i4][i5][i6]-'0';
  j2=ascrule[i2][i3][i4][i5][i6][i7]-'0';
  j3=ascrule[i3][i4][i5][i6][i7][i8]-'0';
  j4=ascrule[i4][i5][i6][i7][i8][i9]-'0';
  j5=ascrule[i5][i6][i7][i8][i9][ia]-'0';
  w=a[i0][i1][i2][i3][i4][i5];
  w*=a[i1][i2][i3][i4][i5][i6];
  w*=a[i2][i3][i4][i5][i6][i7];
  w*=a[i3][i4][i5][i6][i7][i8];
  w*=a[i4][i5][i6][i7][i8][i9];
  w*=a[i5][i6][i7][i8][i9][ia];
  if (w!=0.0) {
    w/=b[i1][i2][i3][i4][i5];
    w/=b[i2][i3][i4][i5][i6];
    w/=b[i3][i4][i5][i6][i7];
    w/=b[i4][i5][i6][i7][i8];
    w/=b[i5][i6][i7][i8][i9];
    }
  x[j0][j1][j2][j3][j4][j5]+=w;
  }
}

/* iterate the 6-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

sixblfreq(mm,nn) int mm, nn; {
int    ii, i0, i1, i2, i3, i4, i5, l, m, n;
double op[KK][KK][KK][KK][KK][KK];
double np[KK][KK][KK][KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;
m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK*KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++) {
  op[i0][i1][i2][i3][i4][i5]=s;
  for (l=0; l<n; l++) videodot(0,m++,i5);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  sixbl(np,op);
  videodot(ii,m++,3);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++) {
    n=(int)(f*np[i0][i1][i2][i3][i4][i5]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i5);
    d=op[i0][i1][i2][i3][i4][i5]-np[i0][i1][i2][i3][i4][i5];
    e+=d<0.0?-d:d;
    op[i0][i1][i2][i3][i4][i5]=np[i0][i1][i2][i3][i4][i5];
    }
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }
for (i0=0; i0<KK; i0++) {
  b[i0]=0.0;
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
    b[i0]+=op[i0][i1][i2][i3][i4][i5];
    }
videocursor(0,BROW+7,0);
printf("(6-block) "); 
for (i0=0; i0<KK; i0++) printf("%2d:%5.3f ",i0,b[i0]);

for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  bb[i0][i1]=0.0;
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  for (i4=0; i4<KK; i4++) {
  for (i5=0; i5<KK; i5++) {
    bb[i0][i1]+=op[i0][i1][i2][i3][i4][i5];
    }} }}}}

videocursor(0,BROW+8,0);
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  printf("%1d%1d:%5.3f ",i0,i1,bb[i0][i1]);
videodot(199-(int)(100.0*bb[1][1]),BORG+(int)(100.0*b[1]),2);
}


/* evaluate the seven-block probabilities after one generation */

svnbl(x,a) double x[KK][KK][KK][KK][KK][KK][KK], 
  a[KK][KK][KK][KK][KK][KK][KK]; {
int    i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, ia, ib;
int    j0, j1, j2, j3, j4, j5, j6;
double w, b[KK][KK][KK][KK][KK][KK];

for (j0=0; j0<KK; j0++)
for (j1=0; j1<KK; j1++)
for (j2=0; j2<KK; j2++)
for (j3=0; j3<KK; j3++)
for (j4=0; j4<KK; j4++)
for (j5=0; j5<KK; j5++) {
for (j6=0; j6<KK; j6++) x[j0][j1][j2][j3][j4][j5][j6]=0.0;
  b[j0][j1][j2][j3][j4][j5]=0.0;
  for (j6=0; j6<KK; j6++) 
    b[j0][j1][j2][j3][j4][j5]+=a[j0][j1][j2][j3][j4][j5][j6];  
  }

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (ia=0; ia<KK; ia++)
for (ib=0; ib<KK; ib++) {
  j0=ascrule[i0][i1][i2][i3][i4][i5]-'0';
  j1=ascrule[i1][i2][i3][i4][i5][i6]-'0';
  j2=ascrule[i2][i3][i4][i5][i6][i7]-'0';
  j3=ascrule[i3][i4][i5][i6][i7][i8]-'0';
  j4=ascrule[i4][i5][i6][i7][i8][i9]-'0';
  j5=ascrule[i5][i6][i7][i8][i9][ia]-'0';
  j6=ascrule[i6][i7][i8][i9][ia][ib]-'0';
  w=a[i0][i1][i2][i3][i4][i5][i6];
  w*=a[i1][i2][i3][i4][i5][i6][i7];
  w*=a[i2][i3][i4][i5][i6][i7][i8];
  w*=a[i3][i4][i5][i6][i7][i8][i9];
  w*=a[i4][i5][i6][i7][i8][i9][ia];
  w*=a[i5][i6][i7][i8][i9][ia][ib];
  if (w!=0.0) {
    w/=b[i1][i2][i3][i4][i5][i6];
    w/=b[i2][i3][i4][i5][i6][i7];
    w/=b[i3][i4][i5][i6][i7][i8];
    w/=b[i4][i5][i6][i7][i8][i9];
    w/=b[i5][i6][i7][i8][i9][ia];
    }
  x[j0][j1][j2][j3][j4][j5][j6]+=w;
  }
}

/* iterate the 7-block parameters to find self-consistent values */
/* mm - length of line	*/
/* nn - number of lines	*/

svnblfreq(mm,nn) int mm, nn; {
int    ii, i0, i1, i2, i3, i4, i5, i6, l, m, n;
double op[KK][KK][KK][KK][KK][KK][KK];
double np[KK][KK][KK][KK][KK][KK][KK];
double b[KK], bb[KK][KK], d, e, f, s;
double t[8];

m=0;
f=(double)mm;
s=1.0/((double)(KK*KK*KK*KK*KK*KK*KK));
n=(int)(f*s);
videodot(0,m++,3);
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++) {
  op[i0][i1][i2][i3][i4][i5][i6]=s;
  for (l=0; l<n; l++) videodot(0,m++,i6);
  }
videodot(0,m++,3);

for (ii=1; ii<=nn; ii++) {
  e=0.0; m=0;
  svnbl(np,op);
  videodot(ii,m++,3);
  for (i0=0; i0<KK; i0++)
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
  for (i6=0; i6<KK; i6++) {
    n=(int)(f*np[i0][i1][i2][i3][i4][i5][i6]);
    if (n>0) for (l=0; l<n; l++) videodot(ii,m++,i6);
    d=op[i0][i1][i2][i3][i4][i5][i6]-np[i0][i1][i2][i3][i4][i5][i6];
    e+=d<0.0?-d:d;
    op[i0][i1][i2][i3][i4][i5][i6]=np[i0][i1][i2][i3][i4][i5][i6];
    }
  videodot(ii,m++,3);
  if (e<=0.0001) break;
  }
for (i0=0; i0<KK; i0++) {
  b[i0]=0.0;
  for (i1=0; i1<KK; i1++)
  for (i2=0; i2<KK; i2++)
  for (i3=0; i3<KK; i3++)
  for (i4=0; i4<KK; i4++)
  for (i5=0; i5<KK; i5++)
  for (i6=0; i6<KK; i6++)
    b[i0]+=op[i0][i1][i2][i3][i4][i5][i6];
  }
videocursor(0,BROW+7,0);
printf("(7-block) "); 
for (i0=0; i0<KK; i0++) printf("%2d:%5.3f ",i0,b[i0]);

for (i0=0; i0<KK; i0++) {
for (i1=0; i1<KK; i1++) {
  bb[i0][i1]=0.0;
  for (i2=0; i2<KK; i2++) {
  for (i3=0; i3<KK; i3++) {
  for (i4=0; i4<KK; i4++) {
  for (i5=0; i5<KK; i5++) {
  for (i6=0; i6<KK; i6++) {
    bb[i0][i1]+=op[i0][i1][i2][i3][i4][i5][i6];
    }} }}}}}

videocursor(0,BROW+8,0);
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
  printf("%1d%1d:%5.3f ",i0,i1,bb[i0][i1]);
videodot(199-(int)(100.0*bb[1][1]),BORG+(int)(100.0*b[1]),2);

for (l=0; l<8; l++) t[l]=0.0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
  t[i0+i1+i2+i3+i4+i5+i6]+=op[i0][i1][i2][i3][i4][i5][i6];

videocursor(0,BROW+3,0);
for (l=0; l<4; l++) printf("%2d:%5.3f ",l,t[l]);
videocursor(0,BROW+4,0);
for (l=4; l<8; l++) printf("%2d:%5.3f ",l,t[l]);

}

/* end probkf.c */
